/*******************************************
紅音製作所 www5.big.or.jp/~high/VENIO/
COPYRIGHT(C)VENIO WORKS ALL RIGHTS RESERVED.
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"

#define WIW 264
#define WIH 120
#define SIZE_Y 5*3
#define SIZE_X 11*3
#define REC 24
#define IMG_MAX 2
#define MAP_A "Map.app/Contents/Resources/mapA.txt"
#define LINE_1 256

SDL_Surface *screen;//ウィンドウ
SDL_Surface *img[IMG_MAX];//画像用
Uint32 now,fps,cnt;//flame late
Uint8 gameMode;//現在のゲームモード

Sint16 mapSizeY,mapSizeX;//読み込むマップの大きさ格納
Sint16 maps[SIZE_Y][SIZE_X]=
{
	{0,0,0,0,0,0,0,0,0,0,0},
	{0,0,1,1,1,1,1,1,1,0,0},
	{0,0,1,2,2,2,2,2,1,0,0},
	{0,0,1,1,1,1,1,3,1,0,0},
	{0,0,0,0,0,0,0,0,0,0,0}
};

struct chara_val//キャラクタの構造体
{
Sint16	poX,poY,//現在座標
        mpX,mpY,//キャラの居るマップ座標
				mov,    //移動に使う
				flg;    //これも
};struct chara_val cha;

struct input_val//キー操作の構造体
{
Uint32	UP,DW,LF,RI;//上下左右
};struct input_val KEY;
//------------------------------------------------------------------------------マップ読み込み
void mapLoad(char *mapTxt)
{
Sint16 poY=0;  Sint16 poX=0;
char line[LINE_1];//一行読み込み用

FILE *mapFile=fopen(mapTxt,"r");
if(mapFile==NULL){puts("マップデータ読み込み失敗");SDL_Quit();return;}

while( fgets(line,  LINE_1,  mapFile) )//データ読み込み
	{
	char *words=strtok(line, ",");//lineを*wordsに格納用
	if(strcmp("MAP_SIZE",  words)==0)//MAP_SIZE格納
		{
		mapSizeY=atoi(strtok(NULL, ","));
		mapSizeX=atoi(strtok(NULL, ","));
		}
	else if(strcmp("DATA  ",  words)==0)//DATA  格納
		{
		for(poX=0;	poX<mapSizeX;	poX++)//X軸格納
		maps[poY][poX]=atoi(strtok(NULL, ","));
		poY+=1;//次へ
		}
	}
fclose(mapFile);
}
//------------------------------------------------------------------------------準備
void inits()
{
int num;
//初期化
if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK|SDL_INIT_AUDIO)<0)
	{
	fprintf(stderr, "SDL が初期化できませんでした: %s\n", SDL_GetError());
	SDL_Quit();return;
	}
screen=SDL_SetVideoMode(WIW,WIH,32,SDL_SWSURFACE);
SDL_WM_SetCaption("Map", NULL);		gameMode=0;
//画像読み込み
img[0]=IMG_Load("Map.app/Contents/Resources/chipA.png");
img[1]=IMG_Load("Map.app/Contents/Resources/charA.png");
for(num=0;	num<IMG_MAX;	num++)
if(!img[num])printf("画像読み込み失敗%d: %s\n",num,IMG_GetError());
//マップ読み込み
mapLoad(MAP_A);
//起動時のキャラの位置と初期化的な事
cha.mpX=0;  cha.mpY=4;	cha.poX=cha.mpX*REC;  cha.poY=cha.mpY*REC;
cha.mov=0;	cha.flg=0;
KEY.UP=0;  KEY.DW=0;  KEY.LF=0;  KEY.RI=0;
}
//------------------------------------------------------------------------------キー入力
void inputChecker()
{
Uint8 *keys=SDL_GetKeyState(NULL);
if		 (keys[SDLK_UP]   ==SDL_PRESSED)	{KEY.UP=1;	cha.mov=0;	cha.flg=1;}
else if(keys[SDLK_DOWN] ==SDL_PRESSED)	{KEY.DW=1;	cha.mov=0;	cha.flg=1;}
else if(keys[SDLK_LEFT] ==SDL_PRESSED)	{KEY.LF=1;	cha.mov=0;	cha.flg=1;}
else if(keys[SDLK_RIGHT]==SDL_PRESSED)	{KEY.RI=1;	cha.mov=0;	cha.flg=1;}
}
//------------------------------------------------------------------------------mapチップ
void mapSrc(Sint16 num, Sint16 poX,Sint16 poY)
{
SDL_Rect src,drw;
src.x=num*REC;	src.y=0;	src.w=REC;	src.h=REC;
drw.x=poX;			drw.y=poY;

SDL_BlitSurface(img[0],&src,screen,&drw);
}
//------------------------------------------------------------------------------map全体描画
void mapDrw()
{
Sint16 poX,poY;
for(poY=0;	poY<mapSizeY;	poY++)
for(poX=0;	poX<mapSizeX;	poX++)
mapSrc(maps[poY][poX], poX*REC,	poY*REC);
}
//------------------------------------------------------------------------------キャラ描画
void chharaSrc(Uint16 poX,Uint16 poY)
{
SDL_Rect src,drw;
src.x=0;  src.y=0;  src.w=REC;  src.h=REC;
drw.x=poX;  drw.y=poY;
SDL_BlitSurface(img[1],&src,screen,&drw);
}
//------------------------------------------------------------------------------キャラ移動
void chharaMov()
{
if(KEY.UP==1)//↑移動の場合
	{
	if(cha.mpY==0 || maps[cha.mpY-1][cha.mpX]==0)
		{
		KEY.UP=0;	cha.flg=0;
		}
	else if( (cha.mov+=1)>REC )
		{
		cha.mpY-=1;	KEY.UP=0;	cha.flg=0;
		}
	else cha.poY-=1;
	}
else if(KEY.DW==1)//↓移動の場合
	{
	if(cha.mpY==mapSizeY-1 || maps[cha.mpY+1][cha.mpX]==0)	{	KEY.DW=0;	cha.flg=0;}
	else if( (cha.mov+=1)>REC ) { cha.mpY+=1;	KEY.DW=0;	cha.flg=0;}
	else cha.poY+=1;
	}
else if(KEY.LF==1)//←移動の場合
	{
	if(cha.mpX==0 || maps[cha.mpY][cha.mpX-1]==0)	{	KEY.LF=0;	cha.flg=0;}
	else if( (cha.mov+=1)>REC ) { cha.mpX-=1;	KEY.LF=0;	cha.flg=0;	}
	else cha.poX-=1;
	}
else if(KEY.RI==1)//→移動の場合
	{
	if(cha.mpX==mapSizeX-1 || maps[cha.mpY][cha.mpX+1]==0)	{	KEY.RI=0;	cha.flg=0;}
	else if( (cha.mov+=1)>REC ) { cha.mpX+=1;	KEY.RI=0;	cha.flg=0;	}
	else cha.poX+=1;
	}
}
//------------------------------------------------------------------------------お家
void house()
{
SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));//バック地
}
//------------------------------------------------------------------------------当たり判定
Uint8 hitCheck(Sint16 poX,Sint16 poY)
{
SDL_Rect R1,R2;
R1.x=poX;			R1.y=poY;			R1.w=REC;	R1.h=REC;//何かの位置
R2.x=cha.poX;	R2.y=cha.poY;	R2.w=REC;	R2.h=REC;//自分の位置
if( (R1.x<(R2.x+R2.w)) && (R2.x<(R1.x+R1.w)) &&
    (R1.y<(R2.y+R2.h)) && (R2.y<(R1.y+R1.h)) ) return 1;
else return 0;
}
//------------------------------------------------------------------------------イベント関係
void allEvents()
{
if(cha.flg==0)
	{
	if(hitCheck(REC*8,REC*1)==1)
		{
		cha.poX=(Sint16)(WIW*0.5-REC*0.5);	cha.poY=(Sint16)(WIH*0.5-REC*0.5);
		gameMode=1;//家の判定
		}
	else inputChecker();//キー入力
	}
}
//------------------------------------------------------------------------------画面更新
void upDate()
{
if(SDL_GetTicks()-now<16)SDL_Delay(16-(SDL_GetTicks()-now));
now=SDL_GetTicks();
SDL_UpdateRect(screen,0,0,0,0);//画面更新
if(SDL_GetTicks()-fps>=5000){printf("%d\n",(Uint32)(cnt/5+0.5));cnt=1;fps=now;}
else cnt++;
}
//------------------------------------------------------------------------------終了へ
int quitLoop()
{
SDL_Event endSDL;
if(SDL_PollEvent(&endSDL))
switch(endSDL.type)
	{
	case SDL_KEYDOWN:
		if(endSDL.key.keysym.sym==SDLK_ESCAPE)return 0;
		break;
	case SDL_QUIT:		return 0;
	default:					break;
	}
return 1;
}
//------------------------------------------------------------------------------メイン
int main(int argc,char *argv[])
{
inits();
while(quitLoop())
	{
	switch(gameMode)
		{
		case 0:
			mapDrw();
			chharaMov();//キャラ移動
			break;
		case 1:
			house();
			break;
		default:break;
		}
	chharaSrc(cha.poX,cha.poY);//キャラ描画
	allEvents();//イベント関係
	upDate();//画面更新
	}
SDL_Quit();
return 0;
}